import sys
from ldif import LDIFParser

class MyParser(LDIFParser):
    def __init__(self, fobj):
        LDIFParser.__init__(self, fobj)

    def handle(self, dn, entry):
        print '*' * 80
        for key in entry:
            print "%s: %s" % (key, ', '.join(entry[key]))


if __name__ == "__main__":
    if len(sys.argv) != 2:
        print "USAGE: %s fname" % sys.argv[0]
        sys.exit(-1)

    try:
        parser = MyParser(open(sys.argv[1]))
    except IOError:
        print 'Wrong file name'
    else:
        parser.parse()
